//CHAPTER 7, ProjectShapes - SOLUTION  //

/**
 * BasicShape is an abstract class which is the root of the
 * shape hierarchy.
 * The BasicShape abstract class provides definitions for objects that represent
 * some form of geometric shape (2D shape)
 * @author OOP Team.
 */
public abstract class BasicShape {

	protected String color;
    
    /**
	* constructor of a shape 
	* can not be generated directly because the class is abstrace
	* can be generated through the down classes
	* @param color : the color of the shape
	*/
	public BasicShape(String color) {
		this.color=color;
	}
    
    /**
	Return shape's color.
	*/
	public String getColor() {
		return this.color;
	}

	/**
	Return shape's identification string.
	*/
	abstract public String toString();
	
	/**
	Return shape's area.
	*/
	abstract public double getArea();
	
	/**
	Return shape's perimeter.
	*/
	abstract public double getPerimeter();
}//close class
