//CHAPTER 7, ProjectShapes - SOLUTION  //

/**
 * A RightAngledTriangle (Triangle with one angle of 90 degrees)
 * specifies an area in a coordinate space
 * that is enclosed by the RightAngledTriangle object's vertex -
 * point (x, y) - that is placed at the 90 degrees angle, its two legs
 * and its hypotenuse.
 * @author OOP Team 
 */
public class RightAngledTriangle extends BasicShape {
	
	private Point vertex;
	private int leg1, leg2;


	/**
	 * Construct new green RightAngledTriangle.
	 * @param x triangle's right angle vertex x coordinate.
	 * @param y triangle's right angle vertex y coordinate.
	 * @param leg1 triangle's one leg.
	 * @param leg2 triangle's second leg.
	 */
	public RightAngledTriangle(Point vertex, int leg1, int leg2) {
		super("green");
		this.vertex=new Point(vertex);
		this.leg1=leg1;
		this.leg2=leg2;
	}

	/**
	 * Return right triangle's identification string.
	 */
	public String toString() {
		return "Right Angled Triangle:\nright angle at: "+vertex+
			" legs: "+leg1+", "+leg2+" color: "+color;
	}

	/**
	 * Return right triangle's area.
	 */
	public double getArea() {
		return 0.5*leg1*leg2;
	}

	/**
	 * Return right triangle's perimeter.
	 */
	public double getPerimeter() {
		return leg1+leg2+Math.sqrt(leg1*leg1+leg2*leg2);
	}
}//close class

