//CHAPTER 7, ProjectShapes - SOLUTION  //
/**
 * ShapeSystem enables the user to choose which geometric shape
 * he/she wants to create. It holds the shapes that were created
 * and then print their details.
 * The user can choose which geometric shape to create
 * using the following menu:
 * Select shape:
 * 1.Circle
 * 2.Rectangle
 * 3.Right Angled Triangle
 * The user can create few different shapes (number of shapes is
 * defined by the programmer) and then ShapeSystem prints the
 * following details of each shape:
 * shape <array index> is: <shape's details> 
 * The area is: <shape's area>
 * The perimeter is:  <shape's perimeter> 
 * @author OOP Team
 */
public class ShapeSystem {

	public static void main(String args[]){
		//number of shapes the user can create.
		final int TOTAL_SHAPES=3;
		
		/*****************************************************
		!!We create an array of BasicShape that
		!!will be initialized by the user.
		!!We do not know how the user will
		!! choose to initialize it.
		*****************************************************/
		BasicShape[] shapes=new BasicShape[TOTAL_SHAPES];
		OutputWindow.println("You can create " +TOTAL_SHAPES+ " shapes\n"+
			"Select shape:\n1. Circle\n2. Rectangle\n3. Right Triangle\n");
		
		/*****************************************************
		!!In this for loop the user initialize the array
		!!We upcast objects of sub-classes to their
		!!super class BasicShape.  
		******************************************************/
		for (int i=0; i<TOTAL_SHAPES; i++) {
			int shape;
			do{
				shape=InputRequestor.requestInt("Please select shape to add (see output window):");
			}while(shape<1 || shape>3);
			int x,y;
            switch (shape) {
            case 1: // The user choose to create a Circle
            	x=InputRequestor.requestInt("New Circle: please enter center X coordinate");
            	y=InputRequestor.requestInt("New Circle: please enter center Y coordinate");
            	int radius=InputRequestor.requestInt("New Circle: please enter the radius");
                shapes[i]=new Circle(new Point(x,y),radius,"blue");
                break;
            case 2://The user choose to create a Rectangle
            	x=InputRequestor.requestInt("New Rectangle: please enter left top X coordinate");
            	y=InputRequestor.requestInt("New Rectangle: please enter left top Y coordinate");
            	int width=InputRequestor.requestInt("New Rectangle: please enter the width");
            	int height=InputRequestor.requestInt("New Rectangle: please enter the height");
                shapes[i]=new Rectangle(new Point(x,y),width,height);
                break;
            case 3://The user choose to create a Right Triangle
            	x=InputRequestor.requestInt("New Triangle: please enter right angle vertex X coordinate");
            	y=InputRequestor.requestInt("New Triangle: please enter right angle vertex Y coordinate");
            	int leg1=InputRequestor.requestInt("New Triangle: please enter one of the legs");
            	int leg2=InputRequestor.requestInt("New Triangle: please enter another leg");
                shapes[i]=new RightAngledTriangle(new Point(x,y),leg1,leg2);
                break;
            }//close switch
		}//close for
		OutputWindow.clear();
		
		/*********************************************
		!!We call the same methods but each
		!!shape executes it differentially.
		**********************************************/
		for (int i=0; i<TOTAL_SHAPES; i++) {
			OutputWindow.println("shape "+i+" is: "+shapes[i]);
			OutputWindow.println("The area is: "+shapes[i].getArea());
			OutputWindow.println("The perimeter is: "+shapes[i].getPerimeter());
			OutputWindow.println();
		}//close for
	}//close main
}
